// MQReciever.cpp : Implementation of CQCReceiver
#include "stdafx.h"
#include "QCClient.h"
#include "QCReceiver.h"

/////////////////////////////////////////////////////////////////////////////
// CQCReceiver

STDMETHODIMP CQCReceiver::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IQCReceiver
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CQCReceiver::Send(BSTR Text)
{
	CComPtr<IEventHelper> spIEventHelper;
	spIEventHelper.CoCreateInstance(CLSID_EventHelper);
	return spIEventHelper->Fire(Text);
}
