	
// MQReciever.h : Declaration of the CQCReceiver

#ifndef __MQRECIEVER_H_
#define __MQRECIEVER_H_

#include "resource.h"       // main symbols
#include "QCClientCP.h"
#include "MTX.h"

/////////////////////////////////////////////////////////////////////////////
// CQCReceiver
class ATL_NO_VTABLE CQCReceiver : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CQCReceiver, &CLSID_QCReceiver>,
	public ISupportErrorInfo,
	public IDispatchImpl<IQCReceiver, &IID_IQCReceiver, &LIBID_QCClientLib>
	//public IObjectControl

{
public:
	CQCReceiver() { 
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_QCRECEIVER)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CQCReceiver)
	COM_INTERFACE_ENTRY(IQCReceiver)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CQCReceiver)
END_CONNECTION_POINT_MAP()


	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMQReciever
public:
	STDMETHOD(Send)(/*[in]*/ BSTR Text);
};

#endif //__MQRECIEVER_H_
