// MessServObj.h : Declaration of the CMessServObj

#ifndef __MESSSERVOBJ_H_
#define __MESSSERVOBJ_H_

#include "resource.h"       // main symbols
#include "..\QCClient\QCClient.h"


/////////////////////////////////////////////////////////////////////////////
// CMessServObj
class ATL_NO_VTABLE CMessServObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMessServObj, &CLSID_MessServObj>,
	public IDispatchImpl<IMessServObj, &IID_IMessServObj, &LIBID_MESSSRVLib>
{
public:
	CMessServObj();
	
DECLARE_REGISTRY_RESOURCEID(IDR_MESSSERVOBJ)
DECLARE_NOT_AGGREGATABLE(CMessServObj)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMessServObj)
	COM_INTERFACE_ENTRY(IMessServObj)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IMessServObj
public:
	STDMETHOD(MSMQTestInit)();
	STDMETHOD(Play)();
	STDMETHOD(Send)(/*[in]*/ BSTR Text, /*[in]*/  SendMode Mode, /*[in]*/ VARIANT_BOOL AutoPlay);

private:
	
};

#endif //__MESSSERVOBJ_H_
